#ifndef PKMNLIB_STATCALCULATOR_HPP
#define PKMNLIB_STATCALCULATOR_HPP

#include <CreatureLib/Battling/Library/BattleStatCalculator.hpp>
#include "../../Library/Statistic.hpp"

namespace PkmnLib::Battling {
    class Pokemon;

    class StatCalculator final : public CreatureLib::Battling::BattleStatCalculator {
    protected:
        virtual uint32_t CalculateHealthStat(const Pokemon* pkmn) const;
        virtual uint32_t CalculateOtherStat(const Pokemon* pkmn, CreatureLib::Library::Statistic stat) const;
        virtual float GetStatBoostModifier(const CreatureLib::Battling::Creature* pkmn,
                                           CreatureLib::Library::Statistic stat) const;

    public:
        ~StatCalculator() override = default;
        CreatureLib::Library::StatisticSet<uint32_t>
        CalculateFlatStats(CreatureLib::Battling::Creature* creature) const override;

        CreatureLib::Library::StatisticSet<uint32_t>
        CalculateBoostedStats(CreatureLib::Battling::Creature* creature) const override;

        uint32_t CalculateFlatStat(CreatureLib::Battling::Creature* creature,
                                   CreatureLib::Library::Statistic stat) const override;

        uint32_t CalculateBoostedStat(CreatureLib::Battling::Creature* creature,
                                      CreatureLib::Library::Statistic stat) const override;
    };
}

#endif // PKMNLIB_STATCALCULATOR_HPP
