#ifndef PKMNLIB_ITEMLIBRARY_HPP
#define PKMNLIB_ITEMLIBRARY_HPP

#include <CreatureLib/Library/ItemLibrary.hpp>
#include "Item.hpp"
namespace PkmnLib::Library {
    class ItemLibrary final : public CreatureLib::Library::ItemLibrary {
    public:
        inline std::optional<ArbUt::BorrowedPtr<const Item>> TryGet(const ArbUt::BasicStringView& name) const {
            auto res = CreatureLib::Library::ItemLibrary::TryGet(name.GetHash());
            if (!res.has_value())
                return {};
            return res.value().ForceAs<const Item>();
        }

        inline ArbUt::BorrowedPtr<const Item> Get(const ArbUt::BasicStringView& name) const {
            return CreatureLib::Library::ItemLibrary::Get(name).ForceAs<const Item>();
        }
        inline ArbUt::BorrowedPtr<const Item> operator[](const ArbUt::BasicStringView& name) const { return Get(name); }
    };
}

#endif // PKMNLIB_ITEMLIBRARY_HPP
