#ifndef PKMNLIB_POKEMONFORME_HPP
#define PKMNLIB_POKEMONFORME_HPP

#include <CreatureLib/Library/CreatureData/SpeciesVariant.hpp>
#include "LearnableMoves.hpp"

namespace PkmnLib::Library {
    class PokemonForme final : public CreatureLib::Library::SpeciesVariant {
    public:
        PokemonForme(const ArbUt::StringView& name, float height, float weight, uint32_t baseExperience,
                     const ArbUt::List<uint8_t>& types, CreatureLib::Library::StatisticSet<uint16_t> baseStats,
                     const ArbUt::List<ArbUt::BorrowedPtr<const CreatureLib::Library::Talent>>& talents,
                     const ArbUt::List<ArbUt::BorrowedPtr<const CreatureLib::Library::Talent>>& secretTalents,
                     const LearnableMoves* moves, std::unordered_set<uint32_t> flags = {});

    private:
    public:
        inline const ArbUt::BorrowedPtr<const CreatureLib::Library::Talent>&
        GetAbility(const CreatureLib::Library::TalentIndex& index) const {
            return GetTalent(index);
        }
    };
}

#endif // PKMNLIB_POKEMONFORME_HPP
