#include "RegisterParty.hpp"
#include <CreatureLib/Battling/Models/BattleParty.hpp>
#include "../../../../Battling/Pokemon/PokemonParty.hpp"
#include "../HelperFile.hpp"

void RegisterParty::Register(asIScriptEngine* engine) {
    RegisterPartyClass(engine);
    RegisterBattleParty(engine);
}

static PkmnLib::Battling::Pokemon* GetAtIndexWrapper(PkmnLib::Battling::PokemonParty* obj, size_t i) {
    auto v = obj->GetAtIndex(i);
    if (v.HasValue()) {
        return v.GetValue();
    }
    return {};
}

void RegisterParty::RegisterPartyClass(asIScriptEngine* engine) {
    Ensure(engine->RegisterObjectType("Party", 0, asOBJ_REF | asOBJ_NOCOUNT) >= 0);
    // GetParty() has both a const and a non const variant, so we need to explicitly mention its return type.
    REGISTER_EXPLICIT_GETTER("Party", "const narray<Pokemon@>@ get_Pokemon() const property",
                             CreatureLib::Battling::CreatureParty, GetParty,
                             const ArbUt::OptionalUniquePtrList<CreatureLib::Battling::Creature>&);
    REGISTER_GETTER("Party", "uint64 get_Length() const property", CreatureLib::Battling::CreatureParty, GetLength);

    auto r = engine->RegisterObjectMethod("Party", "Pokemon@ GetAtIndex(int index) const",
                                          asFUNCTION(GetAtIndexWrapper), asCALL_CDECL_OBJFIRST);
    Ensure(r >= 0);
}

void RegisterParty::RegisterBattleParty(asIScriptEngine* engine) {
    Ensure(engine->RegisterObjectType("BattleParty", 0, asOBJ_REF | asOBJ_NOCOUNT) >= 0);
    REGISTER_GETTER("BattleParty", "Party@ get_Party() const property", CreatureLib::Battling::BattleParty, GetParty);
}
